;Sample POOL code, you may use it, modify it
;and distribute it under the GPL license.
;Authors: R&D Independent Team
;Source: www.pool-rnd.com

include "attractor.l

;some initial values:
"init := {-1.164 1.41 -1.42 -1.6}
;values for base class f and g formulas:
;"init := {1.7 1.7 0.6 1.2}
;"init := {-1.9 -2.8 -1.1 0.3} setbg "black
;"init := {1.5 -1.8 1.6 0.9}
;"init := {-1.7 1.3 -0.1 -1.2}
;"init := {-1.7 1.8 -1.9 -0.4}
;"init := {-1.8 -2.0 -0.5 -0.9}

"p := newarray 4
:p,1 := (slider "t1 {8 45 164} {-3 3} :init,1)
:p,2 := (slider "t2 {8 90 164} {-3 3} :init,2)
:p,3 := (slider "t3 {8 135 164} {-3 3} :init,3)
:p,4 := (slider "t4 {8 180 164} {-3 3} :init,4)

to custom_attractor
  use attractor

  ;override f and g functions to change attractor
  ;or comment out to use base class formulas
  to f
    op (radsin :t,1 * :xy,2) - (radcos :t,2 * :xy,1)
  end
  to g
    op (radsin :t,3 * :xy,1) - (radcos :t,4 * :xy,2)
  end

  to modify_at :pt ;override color function
    let "c pointat :pt
    if runif 1 > (0.01 * :c,4)^(1/4) [
      (setpointat :pt color 10 * :c,4 :c,4 + 0.4)
    ]
  end

  setpalette "hot
end

"a := (newt $custom_attractor)

"bhold := (button "Draw {8 8 80 24} [
  "hold := not :hold
  ifelse :hold [settext :bhold "Draw]
  [go @ :a settext :bhold "Freeze]
])

"bclean := (button "Clean {92 8 80 24} [clean])

"brnd := (button "Random {176 8 80 24} [
  foreach "sl :p [
    setvalue :sl 0.001 * int (runif -1900 1900)
  ]
])

